'use strict'

function translateKey (key) {
  return key.replace(/_/g, '-')
}

// translates the boolean-typed value of a JSON environment option to process arguments
function translateJSONEnvBooleanOptionToOption (logger, options, name, key, argv) {
  if (!options.hasOwnProperty(key)) {
    return
  }

  var option = options[key]
  if (option === true) {
    argv.push('--' + translateKey(key))
  } else if (option === false) {
    argv.push('--no-' + translateKey(key))
  } else {
    logger.error('Option "' + key + '" in ' + name + ' needs to have a boolean value')
    logger.fnDeployServiceError('unknown')
    process.exit(1)
  }
}

module.exports = {
  translateJSONEnvBooleanOptionToOption: translateJSONEnvBooleanOptionToOption
}
