'use strict'

function _updateRejectUnauthorized (ioObject) {
  switch (process.env.NODE_TLS_REJECT_UNAUTHORIZED) {
    case '0':
    case 0:
      ioObject.rejectUnauthorized = false
      break
    default:
      ioObject.rejectUnauthorized = true
      break
  }
  return process.env.NODE_TLS_REJECT_UNAUTHORIZED
}

function ProcessEnv () {
  this.oObject = {}
  _updateRejectUnauthorized(this.oObject)
}

ProcessEnv.prototype.setNodeTlsRejectUnauthorizedToReject = function () {
  process.env.NODE_TLS_REJECT_UNAUTHORIZED = 1
  return _updateRejectUnauthorized(this.oObject)
}

ProcessEnv.prototype.setNodeTlsRejectUnauthorizedToAccept = function () {
  process.env.NODE_TLS_REJECT_UNAUTHORIZED = 0
  return _updateRejectUnauthorized(this.oObject)
}

ProcessEnv.prototype.getObject = function () {
  return this.oObject
}

module.exports.ProcessEnv = ProcessEnv
